#include "stm32f10x.h"
#include "lcd.h"

void init_USART();
void sendString();

char buf[80];
volatile uint8_t cursorState = 0x04;
volatile uint8_t i = 0;

int main(void)
{
  init_USART();
  lcdInit();
  while(1);

}

void sendString() {
	lcdWriteCommand(0x01);
	uint8_t i = 0;
	while (buf[i]!=0) {
		lcdWriteData(buf[i]);
		i++;
	}
	lcdWriteCommand(0xC0);
	i++;
	while (buf[i]!=0xff) {
		lcdWriteData(buf[i]);
		i++;
	}
}

void USART1_IRQHandler(void)
{
  if (USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
  {
    uint8_t data = USART_ReceiveData(USART1);
    switch (data) {
          case 0x01: lcdWriteCommand(LCD_COMMAND_CLEAR);
                  break;
          case 0x02:
                  cursorState |= 0x02;
                  lcdWriteCommand(LCD_COMMAND_ON | cursorState);
                  break;
          case 0x03:
                  cursorState &= ~0x02;
                  lcdWriteCommand(LCD_COMMAND_ON | cursorState);
                  break;
          case 0x04:
                  cursorState |= 0x01;
                  lcdWriteCommand(LCD_COMMAND_ON | cursorState);
                  break;
          case 0x05:
                  cursorState &= ~0x01;
                  lcdWriteCommand(LCD_COMMAND_ON | cursorState);
                  break;
          case 0x06:
                  lcdWriteCommand(LCD_COMMAND_MOVE);
                  break;
          case 0x07:
                  lcdWriteCommand(LCD_COMMAND_MOVE | 0x04);
                  break;
          case 0x08:
                  lcdWriteCommand(LCD_COMMAND_MOVE | 0x08);
                  break;
          case 0x09:
                  lcdWriteCommand(LCD_COMMAND_MOVE | 0x08 | 0x04);
                  break;
          case 0xfe:
                  lcdString(buf);
                  i = 0;
                  break;
          default: buf[i++] = data;
	}
	if (data==0xff) {
		i = 0;
		sendString();
	}
  }
}

void init_USART(){
  
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1, ENABLE);
  
  GPIO_InitTypeDef GPIO_InitStructure;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  
  USART_InitTypeDef USART_InitStructure;
  USART_InitStructure.USART_BaudRate = 9600;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
  USART_Init(USART1, &USART_InitStructure);
  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE); 
  USART_Cmd(USART1, ENABLE);

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
  NVIC_InitTypeDef NVIC_InitStructure;
  NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

}
